{$R-,I-}
program PokazGIF;
uses Dos,Crt,Graph;

const Max=4096;

type RodzajMapyKolorow=(Globalny,Lokalny);
     PrologGIF=record
       Naglowek:Array[1..6] of Char;
       SzerokoscEkranu:Word;
       WysokoscEkranu:Word;
       PoleBitowe:Byte;
       KolorTla:Byte;
       PixelAspectRatio:Byte;
      end;
     TablicaKolorow=Array[Globalny..Lokalny,0..255] of
       record
        Czerwony,Zielony,Niebieski:Byte;
       end;
     OpisObrazu=record
       OdKolumny:Word;
       OdLinii:Word;
       SzerokoscObrazu:Word;
       WysokoscObrazu:Word;
       PoleBitowe:Byte;
      end;

var Prolog:PrologGIF;
    OpisObr:OpisObrazu;
    MapaKolorow:RodzajMapyKolorow;
    BitowNaKolor:Byte;
    LiczbaKolorow:Array[Globalny..Lokalny] of Word;
    JestMapa:Array[Globalny..Lokalny] of Boolean;
    Przeplatany,Koniec:Boolean;
    ZostaloBitow:ShortInt;
    LiczbaBitow,OdIluBitow:Byte;
    IndeksBufora,IndeksDanych,IleBajtow:Word;
    Poziom,OdPoziomu,PoziomStosu:Word;
    PoprzedniKod,AktualnyKod:Word;
    KoniecDanych,Nowy:Word;
    Tymczasowy,Zatrzask:Word;
    Linie,MaxX,MaxY,XEkr,YEkr:Word;
    Etykieta:Byte;
    St,Tr:Integer;
    NaEkran:Procedure(Kolor:Byte);
    NazwaZbioru:String;
    ZbiorGIF:File;
    Kolory:TablicaKolorow;
    Slownik:Array[0..Max] of
     record
      Poziom:Word;
      Dana:Byte;
     end;
    Stos:Array[0..1024] of Byte;
    Bufor:Array[0..32767] of Byte;

{---------  PREZENTACJA PUNKTOW OBRAZU NA EKRANIE  -------}
{$F+}
procedure NaEkran1(Kolor:Byte);
 begin
  if (XEkr>MaxX) then begin XEkr:=0; Inc(YEkr); end;
  if (YEkr>MaxY) then YEkr:=0;
  if (XEkr<MaxX) and (YEkr<MaxY) then
   PutPixel(XEkr,YEkr,Kolor);
  Inc(XEkr);
 end;

procedure NaEkran2(Kolor:Byte); {Obraz przeplatany}
 const YInc:Array[1..5] of Byte=(8,8,4,2,1);
       YLin:Array[1..5] of Byte=(0,4,2,1,0);
 begin
  if (XEkr>MaxX) then
   begin
    XEkr:=0;
    Inc(YEkr,YInc[Linie]);
    if (YEkr>MaxY) then
     begin
      Inc(Linie);
      YEkr:=YLin[Linie];
     end;
   end;
  if (XEkr<MaxX) and (YEkr<MaxY) then
   PutPixel(XEkr,YEkr,Kolor);
  Inc(XEkr);
 end;

function SetSVGAMode:Integer;
 begin
  SetSVGAMode:=0;
 end;
{$F-}

{------------  POBIERANIE DANYCH ZE ZBIORU GIF  -----------}

function WezBajt:Byte;
 begin
  if (IndeksBufora>=IleBajtow) then
   begin
    BlockRead(ZbiorGIF,Bufor,SizeOf(Bufor),IleBajtow);
    if (IleBajtow=0) then begin WezBajt:=0; exit; end;
    IndeksBufora:=0;
   end;
   WezBajt:=Bufor[IndeksBufora];
   Inc(IndeksBufora);
 end;

procedure WezBlok(var V;Ile:Word);
 var W:Word;
 begin
  if Ile>IleBajtow then W:=IleBajtow else W:=Ile;
  Move(Bufor[IndeksBufora],V,W);
  Dec(Ile,W); Inc(IndeksBufora,W);
  if (IndeksBufora>=IleBajtow) then
   begin
    BlockRead(ZbiorGIF,Bufor,SizeOf(Bufor),IleBajtow);
    if (IleBajtow=0) then exit;
    IndeksBufora:=0;
   end;
  Move(Bufor[IndeksBufora],V,Ile);
  Inc(IndeksBufora,Ile);
 end;

function WezBajtDanych:Word;
 begin
  if (IndeksDanych=0) then IndeksDanych:=WezBajt;
  if (IndeksDanych>=1) then
   begin
    WezBajtDanych:=WezBajt;
    Dec(IndeksDanych);
   end
  else WezBajtDanych:=Max+1;
 end;

function WezKod(IleBitow:Byte):Word;
 const Maska:Array[1..8] of Byte=
       ($01,$03,$07,$0F,$1F,$3F,$7F,$FF);
 var TrzebaBitow,Ile:Byte;
     Kod:Word;
 begin
  TrzebaBitow:=IleBitow;
  Kod:=0;
  while (TrzebaBitow>0) do
   begin
    if (ZostaloBitow<=0) then { jesli zatrzask jest pusty }
     begin
      Zatrzask:=WezBajtDanych;   { zaladuj go ponownie }
      if Zatrzask>Max then
       begin WezKod:=KoniecDanych; exit; end;
      ZostaloBitow:=8;
     end;
    if (TrzebaBitow>=ZostaloBitow) then Ile:=ZostaloBitow
     else Ile:=TrzebaBitow;
    Kod:=Kod or
    ((Zatrzask and Maska[Ile]) shl (IleBitow-TrzebaBitow));
    Zatrzask:=Zatrzask shr Ile;
    Dec(TrzebaBitow,Ile);
    Dec(ZostaloBitow,Ile);
   end;
  WezKod:=Kod;
 end;

{----------------  DEKOMPRESJA OBRAZU  -----------------}

procedure Inicjuj;
 begin
  LiczbaBitow:=OdIluBitow+1;
  Poziom:=1 shl OdIluBitow;
  Nowy:=Poziom; KoniecDanych:=Poziom+1;
  Inc(Poziom,2);
  OdPoziomu:=Poziom;
 end;

procedure Rozpakuj;
 var C:Char;
 begin
  IndeksDanych:=0;
  PoziomStosu:=0;
  ZostaloBitow:=0;
  OdIluBitow:=WezBajt; {pobranie min. dlugosci kodu LZW}
  if OdIluBitow=0 then exit;
  FillChar(Slownik,SizeOf(Slownik),0);
  Inicjuj;
  AktualnyKod:=WezKod(LiczbaBitow);
  while (AktualnyKodKoniecDanych) do
   begin
    if (AktualnyKod=Nowy) then
     begin
      Inicjuj;
      AktualnyKod:=WezKod(LiczbaBitow);
      Slownik[Poziom-1].Dana:=AktualnyKod;
      PoprzedniKod:=AktualnyKod;
      NaEkran(AktualnyKod);
     end
    else
     begin
      Tymczasowy:=AktualnyKod;
      if (AktualnyKod>=Poziom) then {1}
       begin
        AktualnyKod:=PoprzedniKod;
        Stos[PoziomStosu]:=Slownik[Poziom-1].Dana;
        Inc(PoziomStosu);
       end;
      while (AktualnyKod>=OdPoziomu) do {2}
       begin
        Stos[PoziomStosu]:=Slownik[AktualnyKod].Dana;
        AktualnyKod:=Slownik[AktualnyKod].Poziom;
        Inc(PoziomStosu);
       end;
      Stos[PoziomStosu]:=AktualnyKod; {3}
      Inc(PoziomStosu);
      while (PoziomStosu>0) do
       begin
        Dec(PoziomStosu);
        NaEkran(Stos[PoziomStosu]);
       end;
      Slownik[Poziom].Poziom:=PoprzedniKod; {4}
      Slownik[Poziom].Dana:=AktualnyKod;
      Inc(Poziom);
      PoprzedniKod:=Tymczasowy;
      if (Poziom shr LiczbaBitow>0) and (LiczbaBitow<12)
       then Inc(LiczbaBitow); {*}
     end;
    if KeyPressed then begin Koniec:=True; exit; end;
    AktualnyKod:=WezKod(LiczbaBitow);
   end;
  AktualnyKod:=WezKod(LiczbaBitow);
  repeat until KeyPressed;
  while KeyPressed do C:=ReadKey;
 end;

{-----------  POBIERANIE POSZCZEGOLNYCH BLOKOW  ----------}

procedure OminRozszerzenie;
 var B:Byte;
     S:String;
 begin
  B:=WezBajt; {pobranie etykiety bez jej interpretacji}
  B:=WezBajt; {pobranie dlugosci bloku}
  while (B>0) do
   begin
    WezBlok(S,B);
    B:=WezBajt;
   end;
 end;

procedure WezProlog;
 var B:Byte;
 begin
  WezBlok(Prolog,SizeOf(Prolog));
  B:=Prolog.PoleBitowe;
  JestMapa[Globalny]:=(B and $80>0);
  LiczbaKolorow[Globalny]:=1 shl (B and $07+1);
  BitowNaKolor:=(B and $7F) shr 4+1;
 end;

procedure WezOpisObrazu;
 var B:Byte;
 begin
  WezBlok(OpisObr,SizeOf(OpisObr));
  B:=OpisObr.PoleBitowe;
  JestMapa[Lokalny]:=(B and $80>0);
  LiczbaKolorow[Lokalny]:=1 shl (B and $07+1);
  Przeplatany:=(B and $40>0);
  MaxX:=OpisObr.SzerokoscObrazu-1;
  MaxY:=OpisObr.WysokoscObrazu-1;
 end;

procedure WezKolory;
 var f,Ile:Word;
     Plik:Text;
 begin
  Ile:=LiczbaKolorow[MapaKolorow];
  Ile:=Ile*3;
  WezBlok(Kolory[MapaKolorow],Ile);
 end;

procedure DefiniujKolory;
 var W:Word;
     Reg:Registers;
 begin
  for W:=0 to LiczbaKolorow[MapaKolorow]-1 do
   with Kolory[MapaKolorow][W] do
    begin
     Czerwony:=Czerwony shr 2;
     Zielony:=Zielony shr 2;
     Niebieski:=Niebieski shr 2;
    end;
  Reg.AX:=$1012;
  Reg.BX:=0;
  Reg.CX:=LiczbaKolorow[MapaKolorow];
  Reg.ES:=Seg(Kolory);
  Reg.DX:=Ofs(Kolory[MapaKolorow]);
  Intr($10,Reg);
 end;

{--------------------  PROGRAM GLOWNY  -----------------}

begin
 if (ParamCount=0) then
  begin
   Write('Podaj nazwe zbioru => ');
   Readln(NazwaZbioru);
  end
 else NazwaZbioru:=ParamStr(1);
 if (Pos('.',NazwaZbioru)=0) then
  NazwaZbioru:=NazwaZbioru+'.GIF';
 Assign(ZbiorGIF,NazwaZbioru);
 Reset(ZbiorGIF,1);
 if (IOResult0) then exit;
 IleBajtow:=0;
 IndeksBufora:=0;
 WezProlog;
 with Prolog do
 if (Naglowek'GIF87a') and (Naglowek'GIF89a') then
  begin
   Close(ZbiorGIF);
   Writeln('Zbior nie jest zgodny z formatem GIF !');
   exit;
  end;
 MapaKolorow:=Globalny;
 if JestMapa[Globalny] then WezKolory;
 St:=InstallUserDriver('SVGA256',@SetSVGAMode);
 St:=Detect;
 InitGraph(St,Tr,'');
 Koniec:=False;
 repeat
  Etykieta:=WezBajt;
  case Etykieta of
   $2C:begin
       WezOpisObrazu;
       if Przeplatany then
        begin Linie:=1; NaEkran:=NaEkran2; end
       else NaEkran:=NaEkran1;
       if JestMapa[Lokalny] then
        begin
         MapaKolorow:=Lokalny;
         WezKolory;
        end;
       DefiniujKolory;
       XEkr:=0; YEkr:=0;
       Rozpakuj;
       MapaKolorow:=Globalny;
      end;
    $21:OminRozszerzenie;
    0,$3B:Koniec:=True;
  end;
 until Koniec;
 CloseGraph;
 Close(ZbiorGIF);
end.
